Graphics3D 800,600,32,2
SetBuffer BackBuffer() 
SeedRnd MilliSecs()

Global GraphWmid = GraphicsWidth() Shr 1
Global GraphHmid = GraphicsHeight() Shr 1

Local font=LoadFont("arial cyr",20,1,0,0)
SetFont font


Global mx, my, mxs#, mys#, mhLeft



Global fpsindex#,fpstime#,fpsfold_millisecs#,fpsfps#
Global Life_user#,Ybito
Const MaxHealth=100
Const Player_T=1,Map_T=2,shot_T=3,Bot_T=4
Collisions  Player_T,Map_T,2,3
Collisions  shot_T,Map_T,2,1
Collisions  shot_T,Bot_T,2,1
Collisions  Bot_T,Map_T,2,3
Collisions  Bot_T,Player_T,2,3
Collisions  Bot_T,Bot_T,2,3


Type Player
	Field entity
	Field gunModel
	Field state
	Field Healph#, maxHealph#
	Field Kills
	Field grav#
End Type
Global P.Player

Global spr_shot = LoadSprite("Image\shot.bmp") 
HideEntity spr_shot



Global camera= CreateCamera()
CameraFogMode camera,1
CameraFogRange camera,1,900
CameraRange camera,0.01,1000
CameraFogColor camera,140,200,250


;Global gun
;gun=LoadMesh("Models\Gun\gun.3ds",camera)
;ScaleEntity gun, 0.1, 0.1, 0.1
;RotateEntity gun, -95, 110, 10
;PositionEntity gun,1,-1,1.8

;PositionEntity user,0,5,0
;EntityRadius user,3
;EntityAlpha user,0
;EntityType user,Player_T


Type shot
	Field entity
	Field dist#
End Type


Type Bot
	Field entity
End Type


Function CreatePlayer(x#,y#,z#,yaw#)
	P.Player = New Player
	P\entity = CreatePivot()
	
	RotateEntity camera, 0, 0, 0
	PositionEntity camera,0,6,0
	EntityParent camera, P\entity
	
	P\gunModel = LoadMesh("Models\Gun\gun.3ds")
	ScaleMesh P\gunModel, 0.1, 0.1, 0.1
	RotateMesh P\gunModel, 95, 80, 10
	
	EntityParent P\gunModel, camera
	PositionEntity P\gunModel, 1, -1, 1.8, False
	
	
	RotateEntity P\entity, 0, yaw, 0
	PositionEntity P\entity, x, y, z
	EntityRadius P\entity, 3
	EntityType P\entity, Player_T
	
	
	P\maxHealph = 100
	P\Healph = P\maxHealph
End Function


Function UpdatePlayer()
	Local MoveSpeed# = 0.5
	Local maxPitch# = 70
	Local minPitch# = -70
	Local pitch#
	Local pick, ent, colEnt

;--------------- Movement ----------	
	pitch# = EntityPitch(camera,1) + mys*0.5
	If pitch > maxPitch Then
		pitch = maxPitch
	ElseIf pitch < minPitch Then
		pitch = minPitch
	EndIf
	
	RotateEntity camera, pitch, 0, 0, False
	
	TurnEntity P\entity, 0, -mxs*0.5, 0
	MoveEntity P\entity, (KeyDown(32)-KeyDown(30))*MoveSpeed, 0, (KeyDown(17)-KeyDown(31))*MoveSpeed
	colEnt = EntityCollided(P\entity, Map_T)
	If colEnt <> 0 Then
		P\grav = P\grav * 0.8
		If KeyHit(57) Then
			P\grav = P\grav + 1.2
		EndIf
	Else
		P\grav = P\grav - 0.05
	EndIf
	TranslateEntity P\entity, 0, P\grav-0.1, 0
	
;--------------- Shooting -----------
	If mhLeft=1 Then
		pick = CameraPick(camera, GraphWmid, GraphHmid)
		If pick <> 0 Then
			ent = create_Shot(EntityX(P\gunModel,1), EntityY(P\gunModel,1), EntityZ(P\gunModel,1))
			RotateToPoint(ent, PickedX(), PickedY(), PickedZ())
		EndIf
	EndIf
	
;--------------- 
End Function


Function create_Shot(x#,y#,z#)
	Local s.shot=New shot
	s\entity = CopyEntity(spr_shot)
	PositionEntity s\entity, x#, y#, z#
	EntityType s\entity,shot_T
	EntityPickMode s\entity, 2
	
	Return s\entity
End Function

Function update_shot()
	Local a.shot, colEnt
	
	For a.shot=Each shot
		a\dist = a\dist + 3
		If CountCollisions(a\entity) > 0 Then
			FreeEntity a\entity
			Delete a
		Else
			If a\dist > 200 Then
				FreeEntity a\entity
				Delete a
			Else
				MoveEntity a\entity,0,0,3
			EndIf
		EndIf
	Next
End Function


Function create_Bot(x_B#,y_B#,z_B#)
	b.Bot=New Bot
	b\entity=CreateSphere(10)
	PositionEntity b\entity,x_B#,y_B#,z_B#
	EntityRadius b\entity,2.5
	EntityType b\entity,Bot_T
	
	Return True
End Function

Function update_Bot()
	Local r.Bot, colY#
	Local colEnt
	
	For r.Bot=Each Bot
		PointEntity r\entity, P\entity
		MoveEntity r\entity,0,0,.2
		If EntityCollided (r\entity,Map_T) <> 0
	
			colY# = CollisionY(r\entity,1) - EntityY(r\entity,1)
			If colY > -0.5 Then
				TurnEntity r\entity, 0, Rnd(1)*90, 0
			EndIf
		EndIf
		TranslateEntity r\entity,0,-.42,0
		
		colEnt = EntityCollided (r\entity,Player_T)
		If colEnt <> 0 Then P\Healph = P\Healph - 1
		
		If EntityCollided (r\entity,shot_T) <> 0 Then
			P\Kills = P\Kills + 1
			FreeEntity r\entity
			Delete r
			create_Bot(Rnd(-10,10),24,Rnd(-10,10))
		EndIf 
	Next
End Function


Local Pricel=LoadImage("Image\Pricel.bmp")
MidHandle Pricel
Local Life=LoadImage("Image\Life.bmp")
Local Img = LoadImage("Image\Polosa.bmp")
Local ImgH = ImageHeight(Img)         
Local ImgW = ImageWidth(Img)





Local Gora=LoadMesh("Models\map.B3D")
PositionEntity Gora,0,-50,0
ScaleMesh Gora,.03,.03,.03
EntityType Gora,Map_T
EntityPickMode Gora, 2

CreatePlayer(0, 5, 0, 0)


create_Bot(-20,22,-20)
create_Bot(-20,22,-10)
create_Bot(-10,22,10)
Life_user=100
;====================== MAIN LOOP =================================
While Not KeyHit(1) 

	mx = MouseX()
	my = MouseX()
	mxs = MouseXSpeed()
	mys = MouseYSpeed()
	If MouseDown(1) Then
		If mhLeft = 1 Then
			mhLeft = 2
		ElseIf mhLeft = 0 Then
			mhLeft = 1
		EndIf
	Else
		mhLeft = 0
	EndIf

	UpdatePlayer()
	update_Bot()
	update_shot()
	UpdateWorld()
	
	MoveMouse GraphWmid, GraphHmid
	RenderWorld()
	
	DrawImage Pricel,GraphWmid,GraphHmid
	DrawImage Life,10,10
	DrawImageRect Img,78,27,0,0, P\Healph# / P\maxHealph# * ImgW,ImgH
	Text 50,500,"Kills  "+P\Healph,1,1
	Text 50,100,"Kills  "+P\Kills,1,1
	Text 10,200,"FPS:  "+show_fps()
	
	Flip True
Wend

End


Function RotateToPoint(ent, x#, y#, z#)
	Local dx#, dy#, dz#
	Local pitch, yaw#
	
	dx = x - EntityX(ent,1)
	dy = y - EntityY(ent,1)
	dz = z - EntityZ(ent,1)
	pitch = VectorPitch(dx, dy, dz)
	yaw = VectorYaw(dx, dy, dz)
	
	RotateEntity ent, pitch, yaw, 0, True
End Function

Function show_fps()
	fpsindex=fpsindex+1
	fpstime=fpstime+MilliSecs()-fpsfold_millisecs
	If fpstime=>1000
		fpsfps=fpsindex
		fpstime=0
		fpsindex=0
	EndIf
	fpsfold_millisecs=MilliSecs()
	Return fpsfps
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D